package javadocsearch;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import java.net.*;
import java.io.*;

public class jdsearch extends JApplet implements KeyListener, ActionListener {
  
  JTextField input;                    // input field
  Vector data = new Vector();          // holds list of class files
  String path;                         // url path
  HashMap dataAndLinks;                // maps classes to links

  /**
   * constructor
   */
  public jdsearch() {
    init();
  }

  /**
   * start applet running
   */
  public void start () {
    buildList();
    buildPath();
    super.start();
  }

  /**
   * construct gui only - create input field and give it focus
   * add listeners
   * initialize content pane
   */
  public void init() {
    input = new JTextField();
    input.requestFocus();
    input.addActionListener(this);
    input.addKeyListener(this);

    JPanel contentPane = new JPanel();
    contentPane.setLayout(new BorderLayout());
    contentPane.add(input, BorderLayout.CENTER);
    setContentPane(contentPane);
  }

  /**
   * process keyTyped event
   */
  public void keyTyped(KeyEvent e) {
  }

  /**
   * process keyPressed event
   */
  public void keyPressed(KeyEvent e) {
  }

  /**
   * process keyReleased event
   * find match and scroll taggedclasses list to correct position
   */
  public void keyReleased(KeyEvent e) {

    String field = input.getText();
    if ((field.length() == 0) || (field == null)){
      return;
    }

    String value = find( field, data, 0);
    
    try {
      //System.out.println(this.getDocumentBase());
      URL go = new URL(this.getDocumentBase().getProtocol(), "", path+"/taggedclasses-frame.html#"+value);
      //URL go = new URL("file", "", path+"/taggedclasses-frame.html#"+value);
      System.out.println(go.toString());
      //System.out.println(go.getProtocol()+" "+go.getHost()+" "+go.getFile());
      this.getAppletContext().showDocument(go, "packageListFrame");
    }
    catch(MalformedURLException e1) {
      System.out.println("MalformedURL Exception: "+e1.getMessage());
    }
  }

  /**
   * display requested doc
   */
  public void actionPerformed(ActionEvent e) {

    String field = input.getText();
    String file;
    
    if ((field.length() == 0) || (field == null)) {
      file = "overview-summary.html";
    }
    else {
      file = (String)dataAndLinks.get(find(field, data, 0));
    }
    
    try {

      //System.out.println(this.getDocumentBase());
      URL go = new URL(this.getDocumentBase().getProtocol(), "", path+"/"+file);
      //URL go = new URL("file", "", path+"/"+file);
      System.out.println(go.toString());
      //System.out.println(go.getProtocol()+" "+go.getHost()+" "+go.getFile());
      this.getAppletContext().showDocument(go, "classFrame");
      
    }
    catch(MalformedURLException e1) {
      System.out.println("MalformedURL Exception: "+e1.getMessage());
    }
  }

  /**
   * finds URL path of docs
   */
  public void buildPath() {
    path = this.getCodeBase().toString();
    int endSlash = path.lastIndexOf("/");
    int start = path.indexOf("/");
    path = path.substring(start, endSlash);
    endSlash = path.lastIndexOf("/");
    path = path.substring(0, endSlash);
  }

  /**
   * constructs lists of classes and links
   */
  private void buildList() {
    data = new Vector();
    dataAndLinks = new HashMap();
    String [] classNamesAll = classLinks.getClassNames();
    String [] classLinksAll = classLinks.getClassLinks();
    for (int i = 0; i < classNamesAll.length; i++) {
      data.add(classNamesAll[i]);
      dataAndLinks.put(classNamesAll[i], classLinksAll[i]);
    }
  }

  /**
   * matches input with class
   */
  public String find(String typed, Vector in, int pos){

    if (pos >= typed.length()) {
      return (String)in.firstElement();
    }
    Vector new_In = new Vector();

    Iterator it = in.iterator();
    while (it.hasNext()){
      String temp = (String)it.next();
      if ((temp.length() == 0) || (temp == null)) {
        break;
      }
      if (pos >= temp.length()) {
      }
      else if (Character.toLowerCase(temp.charAt(pos)) ==
        Character.toLowerCase(typed.charAt(pos))) {
        new_In.add(temp);
      }
    }

    if (new_In.isEmpty()) {
      return (String)in.firstElement();
    }
    else if (new_In.size() == 1) {
      return (String)new_In.firstElement();
    }
    else {
      pos = pos + 1;
      return find(typed, new_In, pos);
    }

  }
}
  
